diff --git a/debian/patches/http2-r1832566.diff b/debian/patches/http2-r1832566.diff
new file mode 100644
index 0000000000..7ce7335100
--- /dev/null
+++ b/debian/patches/http2-r1832566.diff
@@ -0,0 +1,43 @@
+--- apache2.orig/modules/http2/h2_conn.c
++++ apache2/modules/http2/h2_conn.c
+@@ -240,7 +240,19 @@ apr_status_t h2_conn_run(struct h2_ctx *
+              && mpm_state != AP_MPMQ_STOPPING);
+ 
+     if (c->cs) {
+-        c->cs->state = CONN_STATE_LINGER;
++        switch (session->state) {
++            case H2_SESSION_ST_INIT:
++            case H2_SESSION_ST_IDLE:
++            case H2_SESSION_ST_BUSY:
++            case H2_SESSION_ST_WAIT:
++                c->cs->state = CONN_STATE_WRITE_COMPLETION;
++                break;
++            case H2_SESSION_ST_CLEANUP:
++            case H2_SESSION_ST_DONE:
++            default:
++                c->cs->state = CONN_STATE_LINGER;
++            break;
++        }
+     }
+ 
+     return APR_SUCCESS;
+--- apache2.orig/modules/http2/h2_version.h
++++ apache2/modules/http2/h2_version.h
+@@ -27,7 +27,7 @@
+  * @macro
+  * Version number of the http2 module as c string
+  */
+-#define MOD_HTTP2_VERSION "1.10.16"
++#define MOD_HTTP2_VERSION "1.10.20"
+ 
+ /**
+  * @macro
+@@ -35,7 +35,7 @@
+  * release. This is a 24 bit number with 8 bits for major number, 8 bits
+  * for minor and 8 bits for patch. Version 1.2.3 becomes 0x010203.
+  */
+-#define MOD_HTTP2_VERSION_NUM 0x010a10
++#define MOD_HTTP2_VERSION_NUM 0x010a14
+ 
+ 
+ #endif /* mod_h2_h2_version_h */
diff --git a/debian/patches/series b/debian/patches/series
index 014d958573..21ff3c5da4 100644
--- a/debian/patches/series
+++ b/debian/patches/series
@@ -30,3 +30,4 @@ mod_http2_mem_usage_32bit.diff
 fcgi_crash.diff
 CVE-2018-1333-mod_http2_DoS.diff
 CVE-2018-11763-mod_http2_DoS-SETTINGS.diff
+http2-r1832566.diff
